﻿using UnityEngine;
using System.Collections;

public class PlayerBehaviour : MonoBehaviour
{
	float x;
	float z;
	public float speed = 1f;
	public GameObject swordPrefab;
	private Animator swordAnim;

	// Use this for initialization
	void Start ()
	{
		Transform t = GameObject.FindGameObjectWithTag ("EquipPoint").transform;
		GameObject sword = Instantiate (swordPrefab, Vector3.zero, Quaternion.identity) as GameObject;
		sword.transform.SetParent (t, false);
		// equip sward.

		swordAnim = sword.GetComponent<Animator> ();

	}
	
	// Update is called once per frame
	void Update ()
	{
		x = Input.GetAxis ("Horizontal");
		z = Input.GetAxis ("Vertical");	

		if (Input.GetButtonDown ("Fire1")) {
			swordAnim.SetTrigger ("swing");
		}
		if (Input.GetButtonDown ("Fire2")) {
			swordAnim.SetTrigger ("swingSide");
		}
	}

	void FixedUpdate ()
	{
		if (x != 0 || z != 0) {
			GetComponent<Rigidbody> ().AddForce (new Vector3 (x, 0f, z) * speed, ForceMode.Impulse);
		}

		// Rotation.
		// マウスの位置検知
		Plane tmpPlane = new Plane (Vector3.up, Vector3.zero);
		// マウスカーソルのスクリーン座標。
		Vector3 p = Camera.main.ScreenToWorldPoint (Input.mousePosition);

		Ray ray = Camera.main.ScreenPointToRay (Input.mousePosition);
		float rayDistance;
		if (tmpPlane.Raycast (ray, out rayDistance)) {
			Vector3 point = ray.GetPoint (rayDistance);
			Debug.DrawRay (ray.origin, point);

			// 高さはプレイヤーの高さで補正。
			transform.LookAt (new Vector3 (point.x, transform.position.y, point.z));
		}
	}
}
